﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PythonIDE.ColorText {
    /// <summary>
    /// Interaction logic for MyColorTextBox.xaml
    /// </summary>
    public partial class MyColorTextBox : UserControl, IColorText {

        MyColorTextBox2 mycolortextbox2 = null;


        public MyColorTextBox(MyTextBox mytextbox) {
            InitializeComponent();
            scrollbar.Minimum = 1;
            scrollbar.Maximum = 100;
            scrollbar.Value = 1;
            //scrollbar.ViewportSize = 10;

            mycolortextbox2 = new MyColorTextBox2(this, mytextbox);
            colorpanel.Children.Add(mycolortextbox2);
        }

        private void scrollbar_Scroll(Object sender, System.Windows.Controls.Primitives.ScrollEventArgs e) {
            mycolortextbox2.setStartrow((int)scrollbar.Value);
            //  Basis.Message("scroll: "+ scrollbar.Value, "Info");
        }

        public void colorChanged() {
            mycolortextbox2.colorChanged();
        }

        public void setNumberofRows(int numberOfLines, int numberOfRows) {
            scrollbar.Minimum = 1;
            scrollbar.Maximum = numberOfLines;

            scrollbar.ViewportSize = numberOfRows;
            scrollbar.SmallChange = 1;
            scrollbar.LargeChange = numberOfRows;
        }

        internal void setPosition(int positionDelta) {
            int actualRow = (int)scrollbar.Value;
            if (positionDelta < 0) {  // scroll nach unten
                scrollbar.Value = mycolortextbox2.setStartrow(actualRow + 1);
            }
            else {
                if (actualRow > 1) {
                    scrollbar.Value = mycolortextbox2.setStartrow(actualRow - 1);
                    // scrollbar.Value += 1;
                }
            }

        }

        public void setTypeFaces(Typeface typefaceNormal, Typeface typefaceBold) {
            mycolortextbox2.setTypeFaces(typefaceNormal, typefaceBold);
        }

        public void setActualRow(int actualrow) {
            scrollbar.Value = actualrow;
        }

        public void setFontsize(int size) {
            mycolortextbox2.setFontsize(size);
        }

        public void setTabsize(double tabsize) {
            mycolortextbox2.setTabsize(tabsize);
        }

        public void setModell(MyTextBox mytextbox) {
            mycolortextbox2.setModell(mytextbox);
        }

        public void MyColorTextBox_Window_KeyDown(Object sender, KeyEventArgs e) {
            mycolortextbox2.MyColorTextBox2_KeyDown(sender, e);
        }

    }
}
