﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Drawing;
using System.IO;

namespace PythonIDE {
    class ConstantsVariablen {
        public static int PROG_VERSION = 1;

        public static string C_REG_ADR = "SOFTWARE\\WILHELM\\PYTHON";

        private static Color fontcolor = Color.Black;
        public static Color Fontcolor {
            get { return fontcolor; }
            set {
                fontcolor = value;
                Basis.WriteRegInt(ConstantsVariablen.C_REG_ADR, "fontcolor", fontcolor.ToArgb());
                Basis.WriteRegBool(ConstantsVariablen.C_REG_ADR, "isSet",true);
            }

        }

        private static Color bgcolor = Color.White;
        public static Color BGcolor {
            get { return bgcolor; }
            set {
                bgcolor = value;
                Basis.WriteRegInt(ConstantsVariablen.C_REG_ADR, "bgcolor", bgcolor.ToArgb());
                Basis.WriteRegBool(ConstantsVariablen.C_REG_ADR, "isSet",true);
            }

        }


        private static String workingDir = "";
        public static String WorkingDir {
            get { return workingDir; }
            set {
                if (Directory.Exists(value)) {
                    workingDir = value;
                    Basis.WriteRegString(ConstantsVariablen.C_REG_ADR, "workingDir", workingDir);
                    Basis.WriteRegBool(ConstantsVariablen.C_REG_ADR, "isSet", true);
                }
            }

        }

        private static int tabwidth = 2;
        public static int Tabwidth {
            get { return tabwidth; }
            set {
                if (value > 0) {
                    tabwidth = value;
                    Basis.WriteRegInt(ConstantsVariablen.C_REG_ADR, "tabwidth", tabwidth);
                    Basis.WriteRegBool(ConstantsVariablen.C_REG_ADR, "isSet", true);
                }
            }

        }

        static ConstantsVariablen() {
            if (Basis.ReadRegBool(ConstantsVariablen.C_REG_ADR, "isSet")) {
                int color = Basis.ReadRegInt(ConstantsVariablen.C_REG_ADR, "fontcolor");
                fontcolor = Color.FromArgb(color);
                color = Basis.ReadRegInt(ConstantsVariablen.C_REG_ADR, "bgcolor");
                bgcolor = Color.FromArgb(color);
                tabwidth = Basis.ReadRegInt(ConstantsVariablen.C_REG_ADR, "tabwidth");
                workingDir = Basis.ReadRegString(ConstantsVariablen.C_REG_ADR, "workingDir");
            }
            else {
                workingDir = Environment.CurrentDirectory;
                workingDir = Environment.GetFolderPath(Environment.SpecialFolder.Personal); 
            }
        }
        
        


    }
}
