﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.Windows.Input;

namespace PythonIDE {

    public class MyCommands {
        private static RoutedUICommand openfile;
        private static RoutedUICommand savefile;
        private static RoutedUICommand saveAll;
        private static RoutedUICommand saveasfile;
        private static RoutedUICommand newfile;

        private static RoutedUICommand undo;
        private static RoutedUICommand redo;
        private static RoutedUICommand copy;
        private static RoutedUICommand paste;
        private static RoutedUICommand cut;
        private static RoutedUICommand selectall;
        private static RoutedUICommand deleteTab;

        private static RoutedUICommand find;
        private static RoutedUICommand findAgain;

        private static RoutedUICommand colormemo;
        private static RoutedUICommand colormemoDeleteRegistry;
        private static RoutedUICommand fullscreen;

        private static RoutedUICommand close;


        private static RoutedUICommand start;
        private static RoutedUICommand startDebug;

        private static RoutedUICommand optionen;
        private static RoutedUICommand help;

        private static RoutedUICommand progInfo;


        private static RoutedUICommand closeRegister;
        private static RoutedUICommand register2Left;
        private static RoutedUICommand register2Right;

        private static RoutedUICommand calc;
        private static RoutedUICommand notepad;

        private static RoutedUICommand editor2Notepad;



        static MyCommands() {
            newfile = new RoutedUICommand("New File", "NewFile", typeof(MyCommands));
            newfile.InputGestures.Add(new KeyGesture(Key.N, ModifierKeys.Control));  // ModifierKeys.Alt |

            openfile = new RoutedUICommand("Open File", "OpenFile", typeof(MyCommands));
            openfile.InputGestures.Add(new KeyGesture(Key.O, ModifierKeys.Control));  // ModifierKeys.Alt |

            savefile = new RoutedUICommand("Save File", "SaveFile", typeof(MyCommands));
            savefile.InputGestures.Add(new KeyGesture(Key.S, ModifierKeys.Control));

            saveAll = new RoutedUICommand("SaveAll", "SaveAll", typeof(MyCommands));
            saveAll.InputGestures.Add(new KeyGesture(Key.S, ModifierKeys.Control | ModifierKeys.Shift));

            saveasfile = new RoutedUICommand("Save As", "SaveAsFile", typeof(MyCommands));
            saveasfile.InputGestures.Add(new KeyGesture(Key.F12, ModifierKeys.None));

            undo = new RoutedUICommand("Undo", "undo", typeof(MyCommands));
            undo.InputGestures.Add(new KeyGesture(Key.Z, ModifierKeys.Control));
            redo = new RoutedUICommand("Redo", "redo", typeof(MyCommands));
            redo.InputGestures.Add(new KeyGesture(Key.Y, ModifierKeys.Control));

            copy = new RoutedUICommand("Copy", "Copy", typeof(MyCommands));
            copy.InputGestures.Add(new KeyGesture(Key.C, ModifierKeys.Control));

            paste = new RoutedUICommand("Paste", "Paste", typeof(MyCommands));
            paste.InputGestures.Add(new KeyGesture(Key.V, ModifierKeys.Control));

            cut = new RoutedUICommand("Cut", "Cut", typeof(MyCommands));
            cut.InputGestures.Add(new KeyGesture(Key.X, ModifierKeys.Control));

            selectall = new RoutedUICommand("Select all", "selectall", typeof(MyCommands));
            selectall.InputGestures.Add(new KeyGesture(Key.A, ModifierKeys.Control));

            find = new RoutedUICommand("Find", "find", typeof(MyCommands));
            find.InputGestures.Add(new KeyGesture(Key.F, ModifierKeys.Control));

            findAgain = new RoutedUICommand("Find again", "find again", typeof(MyCommands));
            findAgain.InputGestures.Add(new KeyGesture(Key.F3, ModifierKeys.None));

            colormemo = new RoutedUICommand("Colormemo", "colormemo", typeof(MyCommands));
            colormemo.InputGestures.Add(new KeyGesture(Key.F11, ModifierKeys.None));

            colormemoDeleteRegistry = new RoutedUICommand("colormemoDeleteRegistry", "colormemoDeleteRegistry", typeof(MyCommands));

            fullscreen = new RoutedUICommand("fullscreen", "fullscreen", typeof(MyCommands));
            fullscreen.InputGestures.Add(new KeyGesture(Key.F, ModifierKeys.Control | ModifierKeys.Shift));


            deleteTab = new RoutedUICommand("Remove the aktual file/register", "deleteTab", typeof(MyCommands));



            start = new RoutedUICommand("Start", "start", typeof(MyCommands));
            start.InputGestures.Add(new KeyGesture(Key.F5, ModifierKeys.None));
            startDebug = new RoutedUICommand("Start", "start", typeof(MyCommands));
            startDebug.InputGestures.Add(new KeyGesture(Key.F5, ModifierKeys.Control));

            close = new RoutedUICommand("Close", "close", typeof(MyCommands));


            optionen = new RoutedUICommand("Options", "options", typeof(MyCommands));

            help = new RoutedUICommand("Help", "help", typeof(MyCommands));
            help.InputGestures.Add(new KeyGesture(Key.F1, ModifierKeys.None));

            progInfo = new RoutedUICommand("Program-Info", "progInfo", typeof(MyCommands));

            closeRegister = new RoutedUICommand("Close Register", "closeRegister", typeof(MyCommands));
            closeRegister.InputGestures.Add(new KeyGesture(Key.F4, ModifierKeys.Control));

            register2Left = new RoutedUICommand("Register 2 left", "register2Left", typeof(MyCommands));
            register2Left.InputGestures.Add(new KeyGesture(Key.L, ModifierKeys.Control));
            register2Right = new RoutedUICommand("Register 2 right", "register2Right", typeof(MyCommands));
            register2Right.InputGestures.Add(new KeyGesture(Key.R, ModifierKeys.Control));

            calc = new RoutedUICommand("Calc", "calc", typeof(MyCommands));
            calc.InputGestures.Add(new KeyGesture(Key.C, ModifierKeys.Control | ModifierKeys.Shift));
            notepad = new RoutedUICommand("Notepad", "notepad", typeof(MyCommands));
            notepad.InputGestures.Add(new KeyGesture(Key.N, ModifierKeys.Control | ModifierKeys.Shift));

            editor2Notepad = new RoutedUICommand("Show Python-File in Notepad ", "editor2Notepad", typeof(MyCommands));
            editor2Notepad.InputGestures.Add(new KeyGesture(Key.D2, ModifierKeys.Control));
        }


        public static RoutedUICommand Copy {
            get { return copy; }
        }
        public static RoutedUICommand Paste {
            get { return paste; }
        }
        public static RoutedUICommand Cut {
            get { return cut; }
        }

        public static RoutedUICommand DeleteTab {
            get { return deleteTab; }
        }


        public static RoutedUICommand Newfile {
            get { return newfile; }
        }

        public static RoutedUICommand Openfile {
            get { return openfile; }
        }

        public static RoutedUICommand Savefile {
            get { return savefile; }
        }
        public static RoutedUICommand SaveAll {
            get { return saveAll; }
        }


        public static RoutedUICommand SaveAsfile {
            get { return saveasfile; }
        }


        public static RoutedUICommand Undo {
            get { return undo; }
        }
        public static RoutedUICommand Redo {
            get { return redo; }
        }


        public static RoutedUICommand Selectall {
            get { return selectall; }
        }


        public static RoutedUICommand Find {
            get { return find; }
        }


        public static RoutedUICommand FindAgain {
            get { return findAgain; }
        }


        public static RoutedUICommand Colormemo {
            get { return colormemo; }
        }

        public static RoutedUICommand ColormemoDeleteRegistry {
            get { return colormemoDeleteRegistry; }
        }


        public static RoutedUICommand Fullscreen {
            get { return fullscreen; }
        }


        public static RoutedUICommand Close {
            get { return close; }
        }




        public static RoutedUICommand Optionen {
            get { return optionen; }
        }

        public static RoutedUICommand Help {
            get { return help; }
        }

        public static RoutedUICommand ProgInfo {
            get { return progInfo; }
        }



        public static RoutedUICommand Start {
            get { return start; }
        }
        public static RoutedUICommand StartDebug {
            get { return startDebug; }
        }



        public static RoutedUICommand CloseRegister {
            get { return closeRegister; }
        }


        public static RoutedUICommand Register2Left {
            get { return register2Left; }
        }

        public static RoutedUICommand Register2Right {
            get { return register2Right; }
        }


        public static RoutedUICommand Calc {
            get { return calc; }
        }


        public static RoutedUICommand Notepad {
            get { return notepad; }
        }




        public static RoutedUICommand Editor2Notepad {
            get { return editor2Notepad; }
        }
    }
}
