﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls;
//using System.Windows.Forms;

using System.IO;
using System.Windows.Media;
using System.Windows.Threading;
using System.Windows;
using System.Windows.Input;

namespace PythonIDE {
    public class MyTextBox : DockPanel {

        //System.Windows.Forms.Integration.WindowsFormsHost wfHost = new System.Windows.Forms.Integration.WindowsFormsHost();
        //System.Windows.Forms.TextBox editor = new System.Windows.Forms.TextBox();

        TextBox editor = null;

        // private DispatcherTimer dispatcherTimer = new DispatcherTimer();


        IParentSetRowColumnModify parent = null;
        Window windowsparent = null;
        private MyTabItem tabpage = null;

        String search = "";
        Boolean ignoreCase = false;
        int position = 0;


        public String Search {
            set {
                search = value;
                position = 0;  // sicherheit
            }
        }
        public Boolean IgnoreCase {
            set {
                ignoreCase = value;
                position = 0;
            }
        }


        private String filename = "";
        public String Filename {
            set {
                filename = value;
                tabpage.Title = Basis.getFilename(filename);
            }
            get { return filename; }
        }

        private bool modified = false;

        public Boolean Modified {
            get { return modified; }
            set {
                modified = value;
            }
        }


        public String Text {
            get {
                return editor.Text;
            }
            set {
                editor.Text = value;
            }
        }


        public void setFontsize(int size) {
            editor.FontSize = size;
        }

        public void setMainMenu(Visibility v) {
           // mainMenu.Visibility = v;
        }

        public void loadFile() {
            if (File.Exists(filename)) {
                //String[] lines = File.ReadAllLines(filename);
                editor.Text = File.ReadAllText(filename).Replace("\t", Konst.C_TAB); 
                modified = false;
            }
        }
        public void saveFile() {
            if (File.Exists(filename)) {
                String ext = Basis.getFilenameExt(filename);
                String backupfilename = Basis.changeFilenameExt(filename, "~" + ext);
                File.Copy(filename, backupfilename, true);
            }
            File.WriteAllText(filename, editor.Text.Trim().Replace(Konst.C_TAB, "\t"));
            modified = false;
        }

        public void setColors() {
            SingVar singvar = SingVar.getInstance();
            editor.Foreground = new SolidColorBrush(Color.FromRgb((byte)singvar.FontcolorRed, (byte)singvar.FontcolorGreen, (byte)singvar.FontcolorBlue));
            editor.Background = new SolidColorBrush(Color.FromRgb((byte)singvar.BGcolorRed, (byte)singvar.BGcolorGreen, (byte)singvar.BGcolorBlue));
            //editor.Foreground = System.Drawing.Color.FromArgb(singvar.FontcolorRed, singvar.FontcolorGreen, singvar.FontcolorBlue);
            //editor.Background = System.Drawing.Color.FromArgb(singvar.BGcolorRed, singvar.BGcolorGreen, singvar.BGcolorBlue);
        }


        public Boolean WordWrap {
            get { return editor.TextWrapping == TextWrapping.Wrap; }
            set {
                if (value)
                    editor.TextWrapping = TextWrapping.Wrap;
                else
                    editor.TextWrapping = TextWrapping.NoWrap;
            }
        }

        public MyTextBox(Window windowsparent, IParentSetRowColumnModify parent, MyTabItem tabpage, String filename,  int id) {
            SingVar singvar = SingVar.getInstance();

            editor = new TextBox();
            this.editor.TextWrapping = TextWrapping.Wrap;
            this.editor.AcceptsReturn = true;
            this.editor.AcceptsTab = true;
            this.editor.HorizontalScrollBarVisibility = ScrollBarVisibility.Visible;
            this.editor.VerticalScrollBarVisibility = ScrollBarVisibility.Visible;
            this.editor.MaxLength = 10000;
            editor.TextWrapping = TextWrapping.NoWrap;

            this.editor.FontSize = 12;
            this.editor.FontFamily = new System.Windows.Media.FontFamily("Courier New");


            this.Children.Add(editor);

            this.windowsparent = windowsparent;
            this.Background = Brushes.Yellow;
            this.parent = parent;
            this.tabpage = tabpage;
            this.LastChildFill = true;
            this.filename = filename;
            if (File.Exists(filename)) {
                tabpage.Title = Basis.getFilename(filename);
            }
            else {
                tabpage.Title = "noname";
                editor.Text = "#! /usr/bin/env python3\r\n# coding=utf8\r\n";
            }

            editor.AcceptsReturn = true;
            editor.AcceptsTab = true;
            setColors();

            this.editor.PreviewKeyDown += editor_PreviewKeyDown;
            this.editor.TextChanged += textBox1_TextChanged;

        }

        void editor_PreviewKeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Tab) && Keyboard.Modifiers == ModifierKeys.None) {
                e.Handled = true;
                
                int caretPosition = editor.CaretIndex;
                
                int index_aktLine;
                int lineindex = (editor.GetLineIndexFromCharacterIndex(editor.CaretIndex) + 1);
                if (lineindex <= 0) {
                    index_aktLine = 0;
                }
                else {
                    index_aktLine = editor.GetCharacterIndexFromLineIndex(lineindex - 1);
                }
                
                editor.Text = editor.Text.Insert(caretPosition, "⟶");
                editor.CaretIndex = caretPosition + 1; //  tabWidth;
                

                // editor.Text = editor.Text.Insert(caretPosition, "  "); 
                // editor.CaretIndex = caretPosition + 2;    
                modified = true;
            }
            if ((e.KeyboardDevice.IsKeyDown(Key.LeftCtrl) || e.KeyboardDevice.IsKeyDown(Key.RightCtrl)) && e.Key == Key.C) {
                e.Handled = true;
                this.Copy();
            }
            if ((e.KeyboardDevice.IsKeyDown(Key.LeftCtrl) || e.KeyboardDevice.IsKeyDown(Key.RightCtrl)) && e.Key == Key.V) {
                e.Handled = true;
                this.Paste();
            }
        }

        private void textBox1_TextChanged(object sender, TextChangedEventArgs e) {
            modified = true;
            parent.editorIsModfied();
        }

        public void setFocus() {
            //editor.Focus();
            // editor.DeselectAll();
            // dispatcherTimer.Start();
        }

        private void dispatcherTimer_Tick(object sender, EventArgs e) {
            //CommandManager.InvalidateRequerySuggested();
            // dispatcherTimer.Stop();
            editor.Focus();
            setLineNummer();
            // editor.DeselectAll();
        }



        public void redoClick() {
            editor.Redo();
            editor.Focus();
        }

        public void Undo() {
            editor.Undo();
            editor.Focus();
        }
        public void Copy1() {
            editor.Copy();
            editor.Focus();
        }

        public void Copy() {
            // editor ist in xaml
            String s1 = editor.SelectedText;
            String s = editor.SelectedText.Replace(Konst.C_TAB, "\t");                                          
            Clipboard.SetText(s);
        }


        // editor_PreviewKeyDown
        public void Paste() {
            String s = Clipboard.GetText().Replace("\t", Konst.C_TAB);
            Clipboard.SetText(s);
            editor.Paste();
            editor.Focus();
        }
        public void Cut() {
            editor.Cut();
            editor.Focus();
        }
        public void SelectAll() {
            editor.SelectAll();
            editor.Focus();
        }


        

        private void editor_KeyUp(object sender, System.Windows.Forms.KeyEventArgs e) {
            //setCursor();
            if (e.Control) {
                switch (e.KeyValue) {
                    case 65: SelectAll();  // A
                        break;
                    case 67: Copy();  // C
                        break;
                    case 70: FindExecuted();  // F
                        break;
                    case 80: Paste();  // P
                        break;
                    case 88: Cut();  // X  
                        break;
                }
            }
            else {
                if (e.KeyValue == 114) {
                    searchAgain();
                }
            }
        }


        private void FindExecuted() {
            WFind dialog = new WFind(this.windowsparent);
            dialog.ShowDialog();
            if (dialog.Result) {
                search = dialog.SearchString;
                ignoreCase = dialog.IgnoreCase;
                searchText(search, ignoreCase);
            }
        }

        public void searchText(String search, Boolean ignoreCase) {
            this.search = search;
            this.ignoreCase = ignoreCase;
            position = 0;
            int index;
            if (this.ignoreCase)
                index = editor.Text.IndexOf(search, position, StringComparison.OrdinalIgnoreCase);
            else
                index = editor.Text.IndexOf(search, position);
            position = index + 1;
            if (index > 0) {
                editor.Select(index, search.Length);
                editor.SelectionStart = index;
                // gescrollt wird alleine
                // editor.ScrollToLine( getLinenr(index, editor.Text) );
                //editor.ScrollToHorizontalOffset(                
            }
            else {
                MessageBox.Show("Die Suche war nicht erfolgreich.\r\nSuchwert: " + search,
                    "Suchen", MessageBoxButton.OK, MessageBoxImage.Exclamation);
            }
        }

        public void searchAgain() {
            int index;
            if (this.ignoreCase)
                index = editor.Text.IndexOf(search, position, StringComparison.OrdinalIgnoreCase);
            else
                index = editor.Text.IndexOf(search, position);
            position = index + 1;
            if (index > 0) {
                editor.Select(index, search.Length);
                editor.SelectionStart = index;
                // gescrollt wird alleine
                // editor.ScrollToLine( getLinenr(index, editor.Text) );
                //editor.ScrollToHorizontalOffset(                
            }
        }


        public int getLinenr(int rowindex, String text) {
            string[] splitStrings = { "\r\n" };  // { "\r", "\r\n", "\n" };
            string[] lines = text.Split(splitStrings, StringSplitOptions.None);
            int rowChars = 0;
            for (int i = 0; i < lines.Length - 1; i++) {
                String sLine = lines[i];
                if (rowindex < rowChars) {
                    return i;
                }
                rowChars += lines[i].Length + 2;
            }
            return lines.Length;
        }

        public void setLineNummer() {
            int index_aktLine;
            int charIndex = editor.CaretIndex;
            int lineindex = (editor.GetLineIndexFromCharacterIndex(charIndex) + 1);
            if (lineindex <= 0) {
                index_aktLine = 0;
            }
            else {
                index_aktLine = editor.GetCharacterIndexFromLineIndex(lineindex - 1);
            }
            int columnCount = editor.SelectionStart - index_aktLine + 1;
            parent.setRowColumn(lineindex, columnCount);
        }




    }
}
