﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace PythonIDE {
    public partial class WOptions : Form {

        public bool retcode = false;

        public WOptions() {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterParent;
        }

        private void WOptions_Load(object sender, EventArgs e) {
            panelFontcolor.BackColor = ConstantsVariablen.Fontcolor;
            panelBGColor.BackColor = ConstantsVariablen.BGcolor;
            tTestBox.ForeColor = ConstantsVariablen.Fontcolor;
            tTestBox.BackColor = ConstantsVariablen.BGcolor;
            tTestBox.Text = "The quick brown fox jumps over the lazy dog";
            tWorkingDir.Text = ConstantsVariablen.WorkingDir;
        }

        private void BnOk_Click(object sender, EventArgs e) {
            ConstantsVariablen.Fontcolor = panelFontcolor.BackColor;
            ConstantsVariablen.BGcolor = panelBGColor.BackColor;
            if (Directory.Exists(tWorkingDir.Text)) {
                ConstantsVariablen.WorkingDir = tWorkingDir.Text;
            }
            retcode = true;
            Close();
        }


        private void BnEsc_Click(object sender, EventArgs e) {
            Close();
        }

        private void bnFontColor_Click(object sender, EventArgs e) {
            ColorDialog colorDlg = new ColorDialog();
            colorDlg.AnyColor = true;
            colorDlg.SolidColorOnly = false;
            colorDlg.Color = panelFontcolor.BackColor; 
            if (colorDlg.ShowDialog() == DialogResult.OK) {
                panelFontcolor.BackColor = colorDlg.Color;
                tTestBox.ForeColor = colorDlg.Color;
            }
        }

        private void bnBGColor_Click(object sender, EventArgs e) {
            ColorDialog colorDlg = new ColorDialog();
            colorDlg.AnyColor = true;
            colorDlg.SolidColorOnly = false;
            colorDlg.Color = panelBGColor.BackColor;
            if (colorDlg.ShowDialog() == DialogResult.OK) {
                panelBGColor.BackColor = colorDlg.Color;
                tTestBox.BackColor = colorDlg.Color;
            }
        }

        private void bnSelectWorkingDir_Click(object sender, EventArgs e) {
            FolderBrowserDialog folderBrowserDialog1 = new FolderBrowserDialog();
            if (Directory.Exists(tWorkingDir.Text)) {
                folderBrowserDialog1.SelectedPath = tWorkingDir.Text;
            }
            DialogResult result = folderBrowserDialog1.ShowDialog();
            if (result == DialogResult.OK) {
                tWorkingDir.Text = folderBrowserDialog1.SelectedPath;
            }
        }
    }
}
