﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using System.IO;

namespace PythonIDE {
    /// <summary>
    /// Interaction logic for WOptions.xaml
    /// </summary>
    public partial class WOptions : Window {

        public bool retcode = false;

        private int fontcolorRed = 0; 
        private int fontcolorGreen = 0; 
        private int fontcolorBlue = 0; 

        private int bgcolorRed = 255;
        private int bgcolorGreen = 255;
        private int bgcolorBlue = 255;

        public WOptions(Window parent) {
            // WindowStartupLocation="CenterOwner"
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner
            this.WindowStartupLocation = WindowStartupLocation.CenterOwner; // nur in XAML
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            SingVar singvar = SingVar.getInstance();
            tWorkingDir.Text = singvar.PythonPath;
            fontcolorRed = singvar.FontcolorRed;
            fontcolorGreen = singvar.FontcolorGreen;
            fontcolorBlue = singvar.FontcolorBlue;

            bgcolorRed = singvar.BGcolorRed;
            bgcolorGreen = singvar.BGcolorGreen;
            bgcolorBlue = singvar.BGcolorBlue;
            setColors();
        }

        private void setColors() {
            tForeground.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)fontcolorRed, (byte)fontcolorGreen, (byte)fontcolorBlue));
                // Color.FromRgb((byte)fontcolorRed, (byte)fontcolorGreen, (byte)fontcolorBlue);
            tBackground.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)bgcolorRed, (byte)bgcolorGreen, (byte)bgcolorBlue));
            tTestBox.Foreground = new SolidColorBrush(Color.FromArgb((byte)255, (byte)fontcolorRed, (byte)fontcolorGreen, (byte)fontcolorBlue));
            tTestBox.Background = new SolidColorBrush(Color.FromArgb((byte)255, (byte)bgcolorRed, (byte)bgcolorGreen, (byte)bgcolorBlue));
        }

        private void bnSelectWorkingDir_Click(object sender, RoutedEventArgs e) {
            SingVar singvar = SingVar.getInstance();
            WSelectDirectory dialog = new WSelectDirectory(this,"Select the directory of the python-source files",singvar.PythonPath);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                String path = dialog.SelectDirectory;
                tWorkingDir.Text = dialog.SelectDirectory;
                if (!path.EndsWith("\\")) {
                    path += "\\";
                }
            }

        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            SingVar singvar = SingVar.getInstance();
            if (Directory.Exists(tWorkingDir.Text)) {
                singvar.PythonPath = tWorkingDir.Text.Trim();
            }
            singvar.FontcolorRed=fontcolorRed;
            singvar.FontcolorGreen=fontcolorGreen;
            singvar.FontcolorBlue=fontcolorBlue;

            singvar.BGcolorRed=bgcolorRed;
            singvar.BGcolorGreen=bgcolorGreen;
            singvar.BGcolorBlue=bgcolorBlue;
            retcode = true;
            Close();
        }

        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void bnselectForeground_Click(object sender, RoutedEventArgs e) {
            WColorDialog dialog = new WColorDialog();
            dialog.setColor(fontcolorRed, fontcolorGreen, fontcolorBlue);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                fontcolorRed = dialog.Red; 
                fontcolorGreen = dialog.Green; 
                fontcolorBlue = dialog.Blue;
                setColors();
            }
        }

        private void bnselectBackground_Click(object sender, RoutedEventArgs e) {
            WColorDialog dialog = new WColorDialog();
            dialog.setColor(bgcolorRed, bgcolorGreen, bgcolorBlue);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                bgcolorRed = dialog.Red;
                bgcolorGreen = dialog.Green;
                bgcolorBlue = dialog.Blue;
                setColors();
            }
        }

    }
}
