# coding=utf8

import tkinter
from tkinter import messagebox

# http://www.tutorialspoint.com/python/python_gui_programming.htm
# http://www.tutorialspoint.com/python/tk_text.htm

class MyApp(tkinter.Frame):

	def __init__(self, master=None):
		tkinter.Frame.__init__(self, master)
		self.pack(expand=True, fill="both")
		self.setGUI()

	def setGUI(self):	
		# pack ist wie das DockPanel in WPF
		# erst muessen die "normalen" UI-Elemente eintgetragen werden
		# am Schluss werden die UI-Elemente eingetragen, die fill="both" haben

		inputframe = tkinter.Frame(self)
		inputframe.config(background = "red") #"#FF0000"
		inputframe.pack(fill="x", side="top" )

		self.label1 = tkinter.Label(inputframe, fg="blue", bg="#FFFF00")
		self.label1["text"] = "1. Zahl"
		self.label1.pack(side="left")
	
		self.inputui = tkinter.Entry(inputframe)
		self.inputui.pack(fill="x",padx="5",pady="5")
		

		self.var_zahl1 = tkinter.StringVar()
		self.var_zahl1.set("12")
		self.inputui["textvariable"] = self.var_zahl1

		# ------------------------------------

		inputframe2 = tkinter.Frame(self)
		inputframe2.config(background = "red") #"#FF0000"
		inputframe2.pack(fill="x", side="top" )

		self.label2 = tkinter.Label(inputframe2, fg="red", bg="#00FFFF")
		self.label2["text"] = "2. Zahl"
		self.label2.pack(side="left")
	
		self.inputui2 = tkinter.Entry(inputframe2)
		self.inputui2.pack(expand=True,fill="x",padx="5",pady="5")
		

		self.var_zahl2 = tkinter.StringVar()
		self.var_zahl2.set("13")
		self.inputui2["textvariable"] = self.var_zahl2

		# ------------------------------------


		inputframe3 = tkinter.Frame(self)
		inputframe3.config(background = "red") #"#FF0000"
		inputframe3.pack(fill="x", side="top" )

		self.label3 = tkinter.Label(inputframe3, fg="blue", bg="#00FF00")
		self.label3["text"] = "Ergebnis"
		self.label3.pack(side="left")
	
		self.inputui3 = tkinter.Entry(inputframe3)
		self.inputui3.pack(expand=True,fill="x",padx="5",pady="5")
		

		self.var_zahl3 = tkinter.StringVar()
		self.var_zahl3.set("??")
		self.inputui3["textvariable"] = self.var_zahl3


		# ------------------------------------

		buttonframe = tkinter.Frame(self)
		buttonframe.config(background = "blue") #"#FF0000"
		buttonframe.pack(fill="x", side="bottom" )

		self.bnEsc = tkinter.Button(buttonframe)
		self.bnEsc["text"] = "Beenden"
		self.bnEsc["command"] = self.quit
		self.bnEsc.pack(padx="5", side="right")

		self.bnAction = tkinter.Button(buttonframe)
		self.bnAction["text"] = "Action"
		self.bnAction["command"] = self.onAction
		self.bnAction.pack(side="right")

# -----------------------------------------------


		# nun ein Editor mit fill=both
		editorframe = tkinter.Frame(self)
		editorframe.pack(expand=True,fill="both", side="top" )

		sbx = tkinter.Scrollbar(editorframe, orient="horizontal")
		sbx.pack(fill="x", side="bottom")

		sby = tkinter.Scrollbar(editorframe)
		sby.pack(fill="y", side="right")

		self.editor = tkinter.Text(editorframe)
		self.editor.config(wrap="none")  # wrap="word"  word char 
		self.editor.pack(expand=True, fill="both", padx="5",pady="5")

		self.editor["xscrollcommand"] = sbx.set
		sbx["command"] = self.editor.xview
		self.editor["yscrollcommand"] = sby.set
		sby["command"] = self.editor.yview

# -----------------------------------------------

		def toInt(self,sValue):
			try:
				value=int(sValue)
				return value
			except:
				return None


	def toFloat(self,sValue):
		try:
			value=float(sValue)
			return value
		except:
			return None

	def onAction(self):
		str1 = self.var_zahl1.get()
		str2 = self.var_zahl2.get()
		zahl1=self.toFloat(str1)
		if zahl1==None:
			messagebox.showinfo( "Fehlerhafte 1. Zahl", str1)
			return
		zahl2=self.toFloat(str2)
		if zahl2==None:
			messagebox.showinfo( "Fehlerhafte 2. Zahl", str1)
			return
		self.var_zahl3.set(zahl1+zahl2)
		if zahl2>0:
			str_erg=str(zahl1)+'  +  '+str(zahl2)+' = '+str(zahl1+zahl2)
		else:
			str_erg=str(zahl1)+'  -  '+str(-zahl2)+' = '+str(zahl1+zahl2)
		self.editor.insert("end",str_erg+"\r\n")



root = tkinter.Tk()
root.title("Addition")
root.geometry("300x400")
app = MyApp(root)
app.mainloop()